Description

Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=2135498

Description of problem:

Currently, we can't configure the worker_timeout used by puma workers. The default of 60s is used.

Changing the worker_timeout would allow users to workaround specific issues happening during peak moments. Here's an example

where increasing the timeout would help:

~

~

Oct 14 06:08:45 satellite.example.com foreman: [1290] ! Terminating timed out worker (worker failed to check in within 60 seconds): 2420

~~

Version-Release number of selected component (if applicable):

Actual results:

Not possible to change the default 60s timeout in a supported way.

Expected results:

Have an installer option to define the worker_timeout.

Additional info:

The timeout can be defined with the following line on the file /usr/share/foreman/config/puma/production.rb

~

~

worker_timeout 120

~~

My suggestion is to add a line on the file /usr/share/foreman/config/puma/production.rb that will read a variable to be defined on the

systemd unit, like we do for the number of workers, and min/max threads.

Like this:

~

~

worker_timeout ENV.fetch('FOREMAN_PUMA_WORKER_TIMEOUT', 60).to_i

~~

Then, setting the value FOREMAN_PUMA_WORKER_TIMEOUT on the systemd unit would be enough:

~~~

1. cat /etc/systemd/system/foreman.service.d/installer.conf

[Service]

05/18/2024 1/2

https://bugzilla.redhat.com/show_bug.cgi?id=2135498


User=foreman

Environment=FOREMAN_ENV=production

Environment=FOREMAN_HOME=/usr/share/foreman

Environment=FOREMAN_PUMA_THREADS_MIN=5

Environment=FOREMAN_PUMA_THREADS_MAX=5

Environment=FOREMAN_PUMA_WORKERS=6

Environment=FOREMAN_PUMA_WORKER_TIMEOUT=120 <============ new variable to define the timeout

~~~

Associated revisions

Revision e381a3c7 - 01/23/2023 09:23 AM - Joniel Pasqualetto

Fixes #35641 - Add FOREMAN_PUMA_WORKER_TIMEOUT

This allows configuring the Puma worker_timeout, which specifies

the time before a worker process that has not checked in will

be restarted. It is not recommended to alter this value in normal

operation as that can mask real bugs or improper configuration.

Co-authored-by: Joniel Pasqualetto <jpasqualetto@redhat.com>

Co-authored-by: William Bradford Clark <wclark@redhat.com>

History

#1 - 10/25/2022 06:55 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to William Clark

- Pull request https://github.com/theforeman/puppet-foreman/pull/1091 added

#2 - 01/10/2023 10:25 PM - William Clark

- Project changed from Installer to Foreman

#3 - 01/10/2023 10:28 PM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/9485 added

#4 - 01/10/2023 10:29 PM - William Clark

- Pull request deleted (https://github.com/theforeman/puppet-foreman/pull/1091)

#5 - 01/23/2023 09:23 AM - The Foreman Bot

- Fixed in Releases 3.6.0 added

#6 - 01/23/2023 10:01 AM - Joniel Pasqualetto

- Status changed from Ready For Testing to Closed

Applied in changeset foreman|e381a3c7c2d7b017e573039d34fe86691315b7db.

#7 - 02/28/2023 03:53 PM - Ewoud Kohl van Wijngaarden

- Category set to Performance

- Triaged changed from No to Yes
